from stat import *
import errno, os, sys

from twisted.python import log
from twisted.internet import reactor

from ignite import proto, device

hello_str = 'Hello World!\n'
hello_path = '/hello'

class stat(object):
    pass

class HelloProtocol(proto.FuseProtocol):
    def getattr(self, path):
        ret = stat()
        if path == '/':
            ret.st_mode = S_IFDIR | 0755
            ret.st_nlink = 2
        elif path == hello_path:
            ret.st_mode = S_IFREG | 0444
            ret.st_nlink = 1
            ret.st_size = len(hello_str)
        else:
            return -errno.ENOENT, None
        return 0, ret

    def getdir(self, path, handle, filler):
        if path != '/':
            return -errno.ENOENT
        filler(handle, '.', 0)
        filler(handle, '..', 0)
        filler(handle, hello_path[1:], 0)
        return 0

    def open(self, path, flags):
        print flags
        if path != hello_path:
            return -errno.ENOENT, 0
        if flags & 3 != os.O_RDONLY:
            return -errno.EACCES, 0
        return 0, 0

    def read(self, path, size, offset, handle):
        if path != hello_path:
            return -errno.ENOENT

        return 0, hello_str[offset:offset+size]

if __name__ == '__main__':
    log.startLogging(sys.stdout)
    fd = device.FuseDevice(HelloProtocol())
    reactor.callLater(0, fd.connect, 'mnt')
    reactor.run()

